c****************************************************************
c* HLEV.FOR * Created: 11/29/87		Revised: 		*
c*----------* By: Ed Connell					*
c*     This module contains a FORTRAN layer of subroutines to   *
c* be used as an interface to the assembly portion of the 	*
c* toolkit.							*
c****************************************************************


	SUBROUTINE INIT( mode )
c	This routine is used to set graphics mode
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),mode,fadd(2),func(2)
	data func /0,0/
c------
	pt(1)=mode
	pt(2)=0
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE FINIT
c	This routine is used to terminate graphics mode
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /0,0/
c------
	pt(1)=0
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DERASE
c	This routine is used to erase the display
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /1,0/
c------
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE COLMAP( ind,ir,ig,ib )
c	This routine is used to set a colormap register.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /2,0/
c------
	pt(1)=ind
	pt(2)=ir
	pt(3)=ig
	pt(4)=ib
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE INQMAP( ind,ir,ig,ib )
c	This routine is used to inquire on a colormap register.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /3,0/
c------
	pt(1)=ind
	call EGAC16( func,pt )
	ir=pt(2)
	ig=pt(3)
	ib=pt(4)
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DRWLOG( ltype )
c	This routine is used to set the drawing logic.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ltype,func(2)
	data func /4,0/
c------
	call EGAC16( func,ltype )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DCOLOR( icol )
c	This routine is used to set the drawing color.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),icol,func(2)
	data func /5,0/
c------
	call EGAC16( func,icol )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE MOVEAB( ix,iy )
c	This routine is used to move the current ptsition absolutely.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /6,0/
c------
	pt(1)=ix
	pt(2)=iy	
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DRAWAB( ix,iy )
c	This routine is used to draw a line from the current
c	ptsition to the specified absolute coordinate.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func /7,0/
c------
	pt(1)=ix
	pt(2)=iy
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE POLYAB( nv, pnts, fill )
c	This routine is used to draw a line through the supplied
c	list of absolute vertices.  If "fill" is TRUE, the bounded
c	region will be filled not outlined.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),pnts(*),func(2),nv
	logical fill
c------
	func(2)=nv
	if( fill ) then
		func(1)=9
		call EGAC16( func,pnts )
	else
		func(1)=8
		call EGAC16( func,pnts )
	endif
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RECTAB( ix1,iy1,ix2,iy2,fill )
c	This routine is used to draw a rectangle.  If fill is TRUE,
c	the region will be filled.
c	----------------------------------------------------------------
	common /memcom/ pt
	logical fill
	integer*2 pt(60),func(2)
c------
	pt(1)=ix1
	pt(2)=iy1
	pt(3)=ix2
	pt(4)=iy2
	if( fill ) then
		func(1)=11
	else
		func(1)=10
	endif
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE FLOOD( ix,iy )
c	This routine is used to flood a bounded region.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/12,0/
c------
	pt(1)=ix
	pt(2)=iy
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RLENFL( icol, icnt, direc )
c	This routine is used to perform a run length fill
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/13,0/
c------
	pt(1)=icol
	pt(2)=icnt
	pt(3)=direc
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE LNSTYL( istyle )
c	This routine is used to set the line style.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2),istyle
	data func/14,0/
c------
	call EGAC16( func, istyle )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE FLSTYL( fstyle )
c	This routine is used to set the fill style.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),fstyle(32),func(2)
	data func/15,0/
c------
	call EGAC16( func, fstyle )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE PATBCL( ibcol )
c	This routine is used to set the pattern background color.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/16,0/
c------
	pt(1)=ibcol
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE TEXT( str,ls )
c	This routine is used to draw text on the display
c	"str" is really of type character, it has been declared as
c	type integer*2 for type checking purposes in this module.
c	This should avoid problems with MS FORTRAN 4.0.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ls,func(2)
	integer*2 str
	data func/17,0/
c------
	func(2)=ls
	call EGAC16( func,str )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DFNFNT( iadd,ih,type )
c	This routine is used to define a raster font.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),iadd(2),ih,type,func(2)
	data func/18,0/
c------
	pt(1)=iadd(1)
	pt(2)=iadd(2)
	pt(3)=ih
	pt(4)=type
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RDPBLK( wid,high,buff )
c	This routine is used to read a pixel block.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),wid,high,buff(*),func(2)
	data func/19,0/
c------
	pt(1)=wid
	pt(2)=high
	call getadd( buff, pt(3) )
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE WRPBLK( wid,high,buff )
c	This routine is used to write a pixel block
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),wid,high,buff(*),func(2)
	data func /20,0/
c------
	pt(1)=wid
	pt(2)=high
	call getadd( buff, pt(3) )
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RDBBLK( wid,high,buff )
c	This routine is used to read a bit block.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),wid,high,buff(*),func(2)
	data func/21,0/
c------
	pt(1)=wid
	pt(2)=high
	call getadd( buff, pt(3) )
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE WRBBLK( wid,high,buff )
c	This routine is used to write a bit block
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),wid,high,buff(*),func(2)
	data func/22,0/
c------
	pt(1)=wid
	pt(2)=high
	call getadd( buff, pt(3) )
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE CPYBLK( sx,sy,dx,dy,iw,ih )
c	This routine is used to copy a pixel block
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),sx,sy,dx,dy,iw,ih,func(2)
	data func/23,0/
c------
	pt(1)=sx
	pt(2)=sy
	pt(3)=dx
	pt(4)=dy
	pt(5)=iw
	pt(6)=ih
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RDMASK( mask )
c	This routine is used to set the bit plane read mask.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),mask,func(2)
	data func/24,0/
c------
	call EGAC16( func,mask )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE WRMASK( mask )
c	This routine is used to set the bit plane write mask.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),mask,func(2)
	data func/25,0/
c------
	call EGAC16( func,mask )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RWPAGE( iread,iwrite )
c	This routine is used to set the read and write
c	enabled pages.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/26,0/
c------
	pt(1)=iread
	pt(2)=iwrite
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE VPAGE( ipage )
c	This routine is used to set the visual page.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ipage,func(2)
	data func/27,0/
c------
	call EGAC16( func,ipage )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE PAN( ulx,uly )
c	This routine is used to pan the display.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ulx,uly,func(2)
	data func/28,0/
c------
	pt(1)=ulx
	pt(2)=uly
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE VWAIT( icnt )
c	This routine is used to wait the specified number of
c	vertical retraces.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),icnt,func(2)
	data func/29,0/
c------

	do 10 j=1,icnt
		call EGAC16( func,pt )
10	continue
	return
	end
c
c	****************************************************************
c
	SUBROUTINE INQMEM( imem )
c	This routine is used to determine the amount of graphics
c	memory installed on the EGA.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),imem,func(2)
	data func/30,0/
c------
	call EGAC16( func,imem )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE SPLIT( line )
c	This routine is used to create a split screen display.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),line,func(2)
	data func/31,0/
c------
	call EGAC16( func,line )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE SWIDTH( iwid )
c	This routine is used to set the logical screen width in words.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),iwid,func(2)
	data func/32,0/
c------
	call EGAC16( func,iwid )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE FONADD( hi,inst,fadd )
c	This routine is used to find a raster font in the EGA.
c	It is used for compatability with clone boards.
c	HI   := is cell height
c	INST := 1 installs vector if data is found
c		0 doesn't
c	FADD := 
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),hi,inst,fadd(2),func(2)
	data func/33,0/
c	----------------------------------------------------------------
	pt(1)=hi
	pt(2)=inst
	call EGAC16( func,pt )
	if( pt(1).eq.1 ) then
		fadd(1)=pt(2)
		fadd(2)=pt(3)
	else
		fadd(1)=0
		fadd(2)=0
	endif
	return
	end
c
c	****************************************************************
c
	SUBROUTINE SAVREG( iwid,ihigh,offset,SorR )
c	This routine is used to save a region of the display.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),iwid,ihigh,offset,SorR,func(2)
	data func/34,0/
c------
	pt(1)=iwid
	pt(2)=ihigh
	pt(3)=offset
	pt(4)=SorR
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE LITPEN( ix,iy )
c	This routine is used to read the light pen register
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ix,iy,func(2)
	data func/35,0/
c------
	pt(1)=0
	pt(2)=0
	call EGAC16( func,pt )
	ix=pt(1)
	iy=pt(2)
	return
	end
c
c	****************************************************************
c
	SUBROUTINE SETCUR( ifunc , ix , iy )
c	This routine is used to show or hide the cursor at the specified
c	position on the display.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/36,0/
c------
	if( ifunc.eq.0 ) then
	  pt(1)=0
	  pt(2)=ix
	  pt(3)=iy
	else
	  pt(1)=1
	endif
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DEFCUR( ifc , ibc , imask , ihotx , ihoty )
c	This routine is used to define the color and shape of the
c	graphics cursor.  The shape is determined by two contiguous sets
c	of bits masks background defined first.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),imask(32),ihotx,ihoty,func(2)
	data func/36,0/
c------ set colors
	pt(1)=2
	pt(2)=ifc
	pt(3)=ibc
	call EGAC16( func,pt )
	pt(1)=3
	do 10 j=2,33
		pt(j)=imask(j-1)
10	continue
	pt(34)=ihotx
	pt(35)=ihoty
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE OCLIP( ix1,iy1,ix2,iy2 )
c	This routine is used to set the shaded object clipping
c	boundaries.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),func(2)
	data func/37,0/
c------
	pt(1)=ix1
	pt(2)=iy1
	pt(3)=ix2
	pt(4)=iy2
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE GENSPH( irad,buff ) 
c	This routine is used to generate a shaded sphere.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 buff(*),irad,pt(60),func(2)
	data func/38,0/
c------
	call getadd( buff, pt(1) )
	pt(3)=irad
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE DRWSPH( ix,iy,irad,cols,buff )
c	This routine is used to draw a shaded sphere.
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),buff(*),irad,ix,iy,cols(3),func(2)
	data func/39,0/
c------
	call getadd( buff, pt(1) )
	pt(3)=irad
	pt(4)=ix
	pt(5)=iy
	pt(6)=cols(1)
	pt(7)=cols(2)
	pt(8)=cols(3)
	call EGAC16( func,pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE RDPIXL( ix, iy, icol )
c	This routine is used to read a single pixel from the screen
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ix,iy,icol,func(2)
	data func/40,0/
c------
	pt(1)=ix
	pt(2)=iy
	call EGAC16( func, pt )
	icol=pt(3)
	return
	end
c
c	****************************************************************
c
	SUBROUTINE WRPIXL( ix, iy, icol )
c	This routine is used to write a single pixel to the screen
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ix,iy,icol,func(2)
	data func/41,0/
c------
	pt(1)=ix
	pt(2)=iy
	pt(3)=icol
	call EGAC16( func, pt )
	return
	end
c
c	****************************************************************
c
	SUBROUTINE INQPOS( ix, iy )
c	This routine is used to inquire the current position
c	----------------------------------------------------------------
	common /memcom/ pt
	integer*2 pt(60),ix,iy,func(2)
	data func/42,0/
c------
	call EGAC16( func, pt )
	ix=pt(1)
	iy=pt(2)
	return
	end



