{****************************************************************
* This module is the turbo pascal 4.0 language interface.  It   *
* requires version 4.0 of the compiler, older versions will not *
* work properly.                                                *
* Last Revised: 3/5/88                                          *
****************************************************************}
unit hlev0;

interface

uses crt;

type TK_str = String[255];
     TK_bufftype = array[0..32767] of byte;

var TK_pt, TK_setup: array[0..255] of integer;
    TK_cpt : array[0..15] of byte;
    TK_Func: array[0..1] of integer;
    TK_vstr: TK_str;
    TK_pfunc, TK_port, TK_slen, TK_sval, TK_ms: integer;
    TK_buff: ^TK_bufftype;

procedure ldfont( str : TK_str ; var buff );
procedure pbfile( str : TK_str; var setup; var error: integer );
procedure inqpos( var ix, iy: integer );
procedure wrpixl( ix, iy, icol: integer );
procedure rdpixl( ix, iy: integer; var icol: integer );
procedure drwsph( ix,iy,rad: integer; var ic,buff );
procedure gensph( rad: integer; var buff );
procedure oclip( ix1,iy1,ix2,iy2: integer );
procedure defcur( ifc,ibc: integer ; var im ; ihotx , ihoty: integer );
procedure setcur( ifunc , ix , iy: integer );
procedure litpen( var ix,iy: integer );
procedure savreg( width,height,offset,SorR: integer );
procedure fonadd( height,inst: integer; var bf );
procedure swidth( iwid: integer );
procedure split( line: integer );
procedure inqmem( var imem: integer );
procedure vwait( icnt: integer );
procedure pan( ulx,uly: integer );
procedure vpage( ipage: integer );
procedure rwpage( iread,iwrite: integer );
procedure wrmask( mask: integer );
procedure rdmask( mask: integer );
procedure cpyblk( sx,sy,dx,dy,width,height : integer );
procedure wrbblk( width,height: integer; var buff );
procedure rdbblk( width,height: integer; var buff );
procedure wrpblk( width,height: integer; var buff );
procedure rdpblk( width,height: integer; var buff );
procedure dfnfnt( var fd; height , typ : integer );
procedure text( str: TK_str );
procedure patbcl( ibcol: integer );
procedure flstyl( var fs );
procedure lnstyl( istyle : integer );
procedure rlenfl( icol, icnt, direc: integer );
procedure flood( ix,iy: integer );
procedure rectab( ix1,iy1,ix2,iy2: integer; fill: integer );
procedure polyab( nv: integer; var pnts; fill: integer );
procedure drawab( ix,iy: integer );
procedure moveab( ix,iy: integer );
procedure dcolor( icol: integer );
procedure drwlog( ltype:integer );
procedure inqmap( index:integer; var red, green, blue: integer);
procedure colmap( index, red, green, blue: integer );
procedure derase;
procedure finit;
procedure init( mode:integer );
procedure egac16( var TK_Func; var TK_pt );
procedure xfrvdt( var TK_pt );
procedure tkmous( var TK_ms; var TK_ms; var TK_ms;  var TK_ms );
function tkfile( var TK_cpt; var TK_setup ): integer;


(*  This section should be uncommented if you have the printer drivers.

procedure ibmgpi( var TK_pfunc; var TK_port; var TK_pt );
procedure ibmgpp;
procedure ibmcpi( var TK_pfunc; var TK_port; var TK_pt );
procedure ibmcpp;
procedure epsfxi( var TK_pfunc; var TK_port; var TK_pt );
procedure epsfxp;
procedure hpinit( var TK_pfunc; var TK_port; var TK_pt );
procedure hprint;
procedure ibmiji( var TK_pfunc; var TK_port; var TK_pt );
procedure ibmijp;
*)

{***********************************************************}
procedure TK_SCR_WID;
procedure TK_WSCREEN_BASE;
procedure TK_RSCREEN_BASE;
procedure TK_WRITE_MASK;
procedure TK_READ_MASK;
procedure TK_READ_PIXEL;
procedure TK_ICPX;
procedure TK_ICPY;
procedure TK_VISUAL_OFFSET;
procedure TK_PRINT_BUFF;
procedure TK_PHYS_WID;
procedure TK_PHYS_HI;
procedure TK_COLOR_MAP;
procedure TK_PRINTER_REQUEST;
procedure TK_PRINTER_OFFSET;
procedure TK_FUNC_IN_PROGRESS;
procedure TK_LOGIC;
{***********************************************************}

implementation
{***********************************************************}
procedure TK_SCR_WID; external;
procedure TK_WSCREEN_BASE; external;
procedure TK_RSCREEN_BASE; external;
procedure TK_WRITE_MASK; external;
procedure TK_READ_MASK; external;
procedure TK_READ_PIXEL; external;
procedure TK_ICPX; external;
procedure TK_ICPY; external;
procedure TK_VISUAL_OFFSET; external;
procedure TK_PRINT_BUFF; external;
procedure TK_PHYS_WID; external;
procedure TK_PHYS_HI; external;
procedure TK_COLOR_MAP; external;
procedure TK_PRINTER_REQUEST; external;
procedure TK_PRINTER_OFFSET; external;
procedure TK_FUNC_IN_PROGRESS; external;
procedure TK_SET_BOUNDS; external;
procedure TK_GEN_BALL_IMAGE; external;
procedure TK_DRAW_BALL; external;
procedure TK_LOGIC; external;
{*********************************************************}

procedure egac16( var TK_Func; var TK_pt ); external;
{$L ..\tkit\EGAC16.OBJ}
{$L ..\tkit\EGASOL.OBJ}

procedure tkmous( var TK_ms; var TK_ms; var TK_ms; var TK_ms ); external;
{$L ..\tkit\TKMOUS.OBJ}

procedure xfrvdt( var TK_pt ); external;
{$L ..\tkit\XFRVDT.OBJ}

function tkfile( var TK_cpt; var TK_setup ): integer; external;
{$L ..\tkit\TKFILE.OBJ}


(* This section should be uncommented if you have the printer drivers.

procedure ibmgpi( var TK_pfunc; var TK_port; var TK_pt ); external;
procedure ibmgpp; external;
{$L ..\printers\IBMGP.OBJ}
procedure ibmcpi( var TK_pfunc; var TK_port; var TK_pt ); external;
procedure ibmcpp; external;
{$L ..\printers\IBMCP.OBJ}
procedure epsfxi( var TK_pfunc; var TK_port; var TK_pt ); external;
procedure epsfxp; external;
{$L ..\printers\EPFX.OBJ}
procedure hpinit( var TK_pfunc; var TK_port; var TK_pt ); external;
procedure hprint; external;
{$L ..\printers\HPLASER.OBJ}
procedure ibmiji( var TK_pfunc; var TK_port; var TK_pt ); external;
procedure ibmijp; external;
{$L ..\printers\IBMINK.OBJ} 
*)

{*****************************************************************
        This routine initializes the display.
*}
      procedure init( mode:integer );

      begin
        TK_Func[0]:=0;			    {* Initialize    *}
        TK_Func[1]:=0;
        TK_pt[0]:=mode;                     {* Graphics mode *}
        egac16( TK_Func,TK_pt );
      end;
{*****************************************************************
        This routine terminates graphics mode.
*}
      procedure finit;

      begin
        TK_Func[0]:=0;
        TK_pt[0]:=0;                        {* Text mode *}

        egac16( TK_Func,TK_pt );
        textmode( CO80 );
      end;
{*****************************************************************
        This routine erases the display.
*}
        procedure derase;

        begin
           TK_Func[0]:=1;
           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine sets a colormap register.
*}
        procedure colmap( index, red, green, blue: integer );

        begin
           TK_Func[0]:=2;

           TK_pt[0]:=index;
           TK_pt[1]:=red;
           TK_pt[2]:=green;
           TK_pt[3]:=blue;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to inquire on a colormap register.
*}
        procedure inqmap( index:integer; var red, green, blue: integer);

        begin
           TK_Func[0]:=3;

           TK_pt[0]:=index;

           egac16( TK_Func,TK_pt );

           red:=TK_pt[1];
           green:=TK_pt[2];
           blue:=TK_pt[3];
        end;
{*****************************************************************
        This routine is used to set the drawing logic
*}
        procedure drwlog( ltype:integer );

        begin
           TK_Func[0]:=4;

           egac16( TK_Func,ltype );
        end;
{*****************************************************************
        This routine is used to set the drawing color
*}
        procedure dcolor( icol: integer );

        begin
           TK_Func[0]:=5;

           egac16( TK_Func,icol );
        end;
{*****************************************************************
        This routine is used move the current position.
*}
        procedure moveab( ix,iy: integer );

        begin
           TK_Func[0]:=6;

           TK_pt[0]:=ix;
           TK_pt[1]:=iy;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to draw a line from the current
        position to the specified point.
*}
        procedure drawab( ix,iy: integer );

        begin
           TK_Func[0]:=7;

           TK_pt[0]:=ix;
           TK_pt[1]:=iy;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to draw a polygon.
*}
        procedure polyab( nv: integer; var pnts; fill: integer );

        begin

           TK_Func[1]:=nv;

           if ( fill<>0 ) then
              TK_Func[0]:=9
           else begin
              TK_Func[0]:=8;
           end;

           egac16( TK_Func,pnts );
        end;
{*****************************************************************
        This routine is used to draw a rectangle.
*}
        procedure rectab( ix1,iy1,ix2,iy2: integer; fill: integer );
        begin
           if ( fill<>0 ) then
              TK_Func[0]:=11
           else begin
              TK_Func[0]:=10;
           end;

           TK_pt[0]:=ix1;
           TK_pt[1]:=iy1;
           TK_pt[2]:=ix2;
           TK_pt[3]:=iy2;

           egac16( TK_Func,TK_pt );
        end;
{****************************************************************
        This routine is used to flood a region.
*}
        procedure flood( ix,iy: integer );
        begin
           TK_Func[0]:= 12;

           TK_pt[0]:=ix;
           TK_pt[1]:=iy;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to perform a run length fill.
*}
        procedure rlenfl( icol, icnt, direc: integer );
        begin
           TK_Func[0]:=13;

           TK_pt[0]:=icol;
           TK_pt[1]:=icnt;
           TK_pt[2]:=direc;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to set the line style.
*}
        procedure lnstyl( istyle : integer );
        begin
           TK_Func[0]:=14;

           egac16( TK_Func,istyle );
        end;
{*****************************************************************
        This routine is used to set the fill style.
*}
        procedure flstyl( var fs );
        begin
           TK_Func[0]:=15;
           move( fs, TK_pt, 64 );
           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to set the pattern logic.
*}
        procedure patbcl( ibcol: integer );
        begin
           TK_Func[0]:=16;
           TK_pt[0]:=ibcol;
           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to output a text string.
*}
        procedure text( str: TK_str );
        begin
	   TK_Func[0]:=17;
	   TK_Func[1]:=ord( str[0] );
           move(str[1],TK_pt[0],TK_Func[1]);

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to define a raster font.
*}
        procedure dfnfnt( var fd; height , typ : integer );
           var fadd: array[0..1] of integer absolute fd;
		
        begin
           TK_Func[0]:=18;

           TK_pt[0]:=fadd[0];
           TK_pt[1]:=fadd[1];
           TK_pt[2]:=height;
           TK_pt[3]:=typ;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to read a pixel block.
*}
        procedure rdpblk( width,height: integer; var buff );
        begin
           TK_Func[0]:=19;

           TK_pt[0]:=width;
           TK_pt[1]:=height;
           TK_pt[2]:=ofs(buff);
           TK_pt[3]:=seg(buff);

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to write a pixel block.
*}

        procedure wrpblk( width,height: integer; var buff );
        begin
           TK_Func[0]:=20;

           TK_pt[0]:=width;
           TK_pt[1]:=height;
           TK_pt[2]:=ofs(buff);
           TK_pt[3]:=seg(buff);

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to read a bit block.
*}
        procedure rdbblk( width,height: integer; var buff );
        begin
           TK_Func[0]:=21;

           TK_pt[0]:=width;
           TK_pt[1]:=height;
           TK_pt[2]:=ofs(buff);
           TK_pt[3]:=seg(buff);

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to write a bit block.
*}
        procedure wrbblk( width,height: integer; var buff );
        begin
           TK_Func[0]:=22;

           TK_pt[0]:=width;
           TK_pt[1]:=height;
           TK_pt[2]:=ofs(buff);
           TK_pt[3]:=seg(buff);

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to copy a pixel block.
*}
        procedure cpyblk( sx,sy,dx,dy,width,height : integer );
        begin
           TK_Func[0]:=23;

           TK_pt[0]:=sx;
           TK_pt[1]:=sy;
           TK_pt[2]:=dx;
           TK_pt[3]:=dy;
           TK_pt[4]:=width;
           TK_pt[5]:=height;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to set the plane read mask.
*}
        procedure rdmask( mask: integer );
        begin
           TK_Func[0]:=24;

           egac16( TK_Func, mask );
        end;
{*****************************************************************
        This routine is used to set the plane write mask.
*}
        procedure wrmask( mask: integer );
        begin
           TK_Func[0]:=25;

           egac16( TK_Func, mask );
        end;
{*****************************************************************
        This routine is used to set the read/write enabled pages.
*}
        procedure rwpage( iread,iwrite: integer );
        begin
           TK_Func[0]:=26;

           TK_pt[0]:=iread;
           TK_pt[1]:=iwrite;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to set the visual page.
*}
        procedure vpage( ipage: integer );
        begin
           TK_Func[0]:=27;

           egac16( TK_Func,ipage );
        end;
{*****************************************************************
        This routine is used to pan the display.
*}
        procedure pan( ulx,uly: integer );
        begin
           TK_Func[0]:=28;

           TK_pt[0]:=ulx;
           TK_pt[1]:=uly;
           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to wait for vertical retrace.
*}
        procedure vwait( icnt: integer );
           var i: integer;

        begin
           TK_Func[0]:=29;
           for i:= 1 to icnt do
              egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to determine the amount of graphics
        memory installed.
*}
        procedure inqmem( var imem: integer );
        begin
           TK_Func[0]:=30;

           egac16( TK_Func,imem );
        end;
{*****************************************************************
        This routine is used to create a split screen.
*}
        procedure split( line: integer );
        begin
           TK_Func[0]:=31;

           egac16( TK_Func,line );
        end;
{*****************************************************************
        This routine is used to set the logical screen width.
*}
        procedure swidth( iwid: integer );
        begin
           TK_Func[0]:= 32;

           egac16( TK_Func,iwid );
        end;
{****************************************************************
        This routine is used to find a raster font in the rom.
*}
        procedure fonadd( height,inst: integer; var bf );
           var buff: array [0..1] of integer absolute bf;

        begin
           TK_Func[0]:=33;

           TK_pt[0]:=height;
           TK_pt[1]:=inst;

           egac16( TK_Func,TK_pt );

           if ( TK_pt[0] <> 0 ) then begin
              buff[0]:=TK_pt[1];
	      buff[1]:=TK_pt[2];
           end else begin
              buff[0]:=0;
	      buff[1]:=0;
           end;
        end;
{*****************************************************************
        This routine is used to save a byte region of the display.
*}
        procedure savreg( width,height,offset,SorR: integer );
        begin
           TK_Func[0]:=34;

           TK_pt[0]:=width;
           TK_pt[1]:=height;
           TK_pt[2]:=offset;
           TK_pt[3]:=SorR;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to read the light pen registers
*}
        procedure litpen( var ix,iy: integer );
        begin
           TK_Func[0]:=35;

           egac16( TK_Func,TK_pt );

           ix:=TK_pt[0];
           iy:=TK_pt[1];
        end;
{****************************************************************
        This routine is used to show or hide the cursor at the specified
        position on the display.
*}
        procedure setcur( ifunc , ix , iy: integer );
        begin
           TK_Func[0]:=36;
           if( ifunc = 0 ) then begin
             TK_pt[0]:=0;
             TK_pt[1]:=ix;
             TK_pt[2]:=iy;
           end
           else
             TK_pt[0]:=1;
           
           egac16( TK_Func,TK_pt );
        end;
{****************************************************************
        This routine is used to define the color and shape of the
        graphics cursor.  The shape is determined by two contiguous sets
        of bits masks background defined first.
*}
        procedure defcur( ifc,ibc: integer ; var im ; ihotx , ihoty: integer );
        var
            j: integer;
        imask: array[0..15] of integer absolute im;
        begin
        TK_Func[0]:=36;
{*----- set colors *}
        TK_pt[0]:=2;
        TK_pt[1]:=ifc;
        TK_pt[2]:=ibc;
        egac16( TK_Func , TK_pt );

        TK_pt[0]:=3;
        for j:=1 to 32 do
                 TK_pt[j]:=imask[j-1];

        TK_pt[33]:=ihotx;
        TK_pt[34]:=ihoty;
        egac16( TK_Func , TK_pt );
        end;

{*****************************************************************
        This routine is used to set the object clipping boundaries.
*}
        procedure oclip( ix1,iy1,ix2,iy2: integer );
        begin
           TK_Func[0]:=37;

           TK_pt[0]:=ix1;
           TK_pt[1]:=iy1;
           TK_pt[2]:=ix2;
           TK_pt[3]:=iy2;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to generate a shaded sphere.
*}
        procedure gensph( rad: integer; var buff );
        begin
           TK_Func[0]:=38;

           TK_pt[0]:=ofs(buff);
           TK_pt[1]:=seg(buff);
           TK_pt[2]:=rad;

           egac16( TK_Func,TK_pt );
        end;
{*****************************************************************
        This routine is used to draw a shaded sphere.
*}
        procedure drwsph( ix,iy,rad: integer; var ic,buff );
           var icols: array[0..2] of integer absolute ic;

        begin
           TK_Func[0]:=39;

           TK_pt[0]:=ofs(buff);
           TK_pt[1]:=seg(buff);
           TK_pt[2]:=rad;
           TK_pt[3]:=ix;
           TK_pt[4]:=iy;
           TK_pt[5]:=icols[0];
           TK_pt[6]:=icols[1];
           TK_pt[7]:=icols[2];

           egac16( TK_Func,TK_pt );
        end;
{****************************************************************
	This routine is used to read a single pixel from the screen.
*}
	procedure rdpixl( ix, iy: integer; var icol: integer );
	begin
		TK_Func[0]:=40;
		TK_pt[0]:=ix;
		TK_pt[1]:=iy;
		egac16( TK_Func,TK_pt );
		icol:=TK_pt[2];
	end;
{****************************************************************
	This routine is used to write a single pixel to the screen.
*}
	procedure wrpixl( ix, iy, icol: integer );
	begin
		TK_Func[0]:=41;
		TK_pt[0]:=ix;
		TK_pt[1]:=iy;
		TK_pt[2]:=icol;
		egac16( TK_Func,TK_pt );
	end;
{****************************************************************
	This routine is used to inquire the current position.
*}
	procedure inqpos( var ix, iy: integer );
	begin
		TK_Func[0]:=42;
		egac16( TK_Func, TK_pt );
		ix:=TK_pt[0];
		iy:=TK_pt[1];
	end;

{****************************************************************
*  This routine is used to read and write PC paint brush files
*
*}
   procedure pbfile( str : TK_str; var setup; var error: integer );
   var slen : integer;
   begin
      slen := ord( str[0] );
      move( str[1], TK_cpt[0], slen );
      TK_cpt[slen] := 0;			{ Null Terminate }
      error:= tkfile( TK_cpt, setup );
   end;

{*****************************************************************
        This routine is used to load an HP soft font file into
        the specified buffer and then call DFNFNT.
*}
        procedure ldfont( str : TK_str ; var buff );
        var fh : file;
            fsize,result : integer;
            found : boolean;
        begin
               Assign( fh,str );
               {$I-} Reset( fh ) {$I+} ;
               found := (IOresult = 0);
               if not found then
                  writeln('File Open Error For: ',str )
               else begin
                  fsize := filesize( fh );
                  BlockRead( fh,buff,fsize,result );
                  Close( fh );
                  ;
                  TK_Func[0]:=18;                     {* DFNFNT *}
                  TK_pt[0]:=ofs(buff);
                  TK_pt[1]:=seg(buff);
                  TK_pt[2]:=0;
                  TK_pt[3]:=1;
                  egac16( TK_Func,TK_pt );
                  ;
               end;
        end;
end.

